package AbsenceInput;

# $Id: AbsenceInput.pm 89 2009-07-14 00:12:25Z urban $

use Encode qw(decode_utf8);

require Exporter;
@ISA = qw(Exporter);
@EXPORT_OK = qw(validate_input);
@EXPORT = qw(validate_input);

sub validate_input
{
	my $ref = shift;

	my $res = undef;
	my @out;

	for(my $i = 0; $i < $#{ $ref }; $i += 2) {
		my ($name, $type);
		my ($tag, $val) = @{ $ref }[$i, $i+1];
		if (!defined($val) || length($val) == 0) { next; }
		if (ref($val)) {
			($name, $type, $val) = ($tag, $val->[0], $val->[1]);
		} else {
			($name, $type) = ($tag, $tag);
		}

		my @vals = ref($val) ? @{ $val } : ($val);
		foreach my $v (@vals) {
			my $r = check_val($tag, $type, $v);
			defined($r) && push(@out, $r);
		}
	}

	return @out ? join("<BR>\n", @out)."<BR>\n" : undef;
}

sub check_val
{
	my ($tag, $type, $val) = @_;

	$val = decode_utf8($val);

	#----------------------------------------------
	# validate value
	#----------------------------------------------
	if ($type eq 'num') {
		($val =~ /^\d+$/) || return "$tag [$val] contains non-digit chars";
	}
	elsif ($type eq 'username') {
		if ($val !~ /^[a-z0-9_.,]+$/i) {
			my $tmp = $val;
			$tmp =~ s![a-z0-9_.,]!!ig;
			return "username [$val] contains illegal chars [$tmp] (allowed: a-z0-9_.,)";
		}
	}
	elsif ($type eq 'acl') {
		($val =~ /^\d+:\d+$/) || return "acl [$val] illegal";
	}
	elsif ($type eq 'name') {
		if ($val =~ m![\000-\037\\`]!) {
			return "name [$val] contains illegal chars";
		}
		#if ($val !~ m!^[-a-z0-9_,./ ]+$!i) {
		#	my $tmp = $val;
		#	$tmp =~ s![-a-z0-9_,./ ]!!ig;
		#	return "name [$val] contains illegal chars [$tmp] (allowed: a-z0-9.,/- and blank)";
		#}
	}
	elsif ($type eq 'description') {
		($val =~ m{^[-a-z0-9_,!./ ]+$}i)
			|| return "description [$val] contains illegal chars (allowed: a-z0-9!.,/-)";
	}
	elsif ($type eq 'email') {
		($val =~ /^[-a-z0-9_.]+@([-a-z0-9]+\.?)+$/i)
			|| return "email [$val] invalid";
	}

	return undef;
}

1;
